#include "struttura.h"
#include <iostream>

using namespace std;

Corso leggi_corso(){
    Corso c;
    
    // Legge i dati di una struct Corso
    // Restituisce la struct tramite il 
    // nome della funzione
    cout << "Nome del corso: ";
    cin.ignore();
    cin.getline(c.nome,32);
    
    cout << "Nome del docente: ";
    cin.getline(c.docente,32);
    
    cout << "Numero di crediti: ";
    cin >> c.crediti;
    
    cout << "Numero studenti iscritti: ";
    cin >> c.numiscritti;
            
    return c;
}

void leggi_lista_corsi(Corso lista[],int n){
    for(int i=0; i<n; i++){
        cout << "\nInserire i dati del corso n. " << i+1 << endl;
        lista[i]=leggi_corso();
    }
    
    return;
}


void ordina_lista_corsi(Corso lista[],int n){
    int last,end;
    bool fattoswap;
    
    last = 0;

    do{
        fattoswap = false;
        end = last;
        for (int i = n - 1; i > end; i--)
            if (lista[i].numiscritti < lista[i - 1].numiscritti) {
                Corso appo = lista[i];
                
                lista[i] = lista[i-1];
                lista[i-1] = appo;
                
                last = i;
                fattoswap = true;
            }
    }while(fattoswap);
    
    return;
}


void inserisci(Corso lista[],int n,Corso elem){
    int pos;
    
    // Cerca la posizione dove effettuare l'inserimento
    pos = 0;
    while(pos < n && lista[pos].numiscritti <= elem.numiscritti)
        pos++;
    
    // Libera lo spazio per l'inserimento nell'elenco
    for(int i=n-1; i >= pos; i--)
        lista[i+1] = lista[i];
    
    // Inserisce il nuovo elemento
    lista[pos] = elem;
    
    return;
}

void stampa_lista_corsi(Corso lista[],int n){
    for(int i=0; i<n; i++){
        cout << endl;
        cout << "Corso: " << lista[i].nome << endl;
        cout << "Docente: " << lista[i].docente << endl;
        cout << "Crediti: " << lista[i].crediti << endl;
        cout << "Numero iscritti: " << lista[i].numiscritti << endl;
        cout << endl;
    }
}
